using System;
using System.Xml;
using System.Xml.XPath;
using NEOCOREXMSLib;

namespace NeoCoreFAQ001
{
	/// <summary>
	/// ܂͉񓚁iƂ̂ЂƂ̎}j\IuWFNg
	/// </summary>
	public class XmlQuestionNode : XmlDocument
	{
		private string id;
		private string qid;

		/// <summary>
		/// XmlQuestionNodeIuWFNg𐶐܂
		/// </summary>
		public XmlQuestionNode()
		{
		}

		/// <summary>
		/// m[ḧʒuid,qid^XmlQuestionNodeIuWFNg𐶐܂
		/// </summary>
		/// <param name="id">id</param>
		/// <param name="qid">eid</param>
		public XmlQuestionNode(string id, string qid)
		{
			setID(id, qid);
		}

		/// <summary>
		/// m[ḧʒuid,qid^܂
		/// </summary>
		/// <param name="id">id</param>
		/// <param name="qid">eid</param>
		public void setID(string id, string qid) 
		{
			this.id = id;
			this.qid = qid;
		}

		/// <summary>
		/// id,qidŎʒũm[hdescriptionԂ܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		public string getDescription(NeoCoreAPI neo) 
		{
			return neo.queryXML(this.getQuery() + "/from/description");
		}

		/// <summary>
		/// ݂Xmlf[^id,qidŎw肳ꂽʒuNeoCodeɃCT[g܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		/// <param name="target">܂͉񓚂 "question"/"answer"</param>
		public void insertNode(NeoCoreAPI neo, string target)
		{
			neo.insertXML(this.getQuery() + "/date", this.OuterXMLforStore(neo, target));
		}

		/// <summary>
		/// id,qidŎw肳ꂽʒũm[hNeoCore폜܂
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		public void deleteNode(NeoCoreAPI neo) 
		{
			if ( ( this.id.Length > 0 ) && ( this.qid.Length > 0 ) ) 
			{
				neo.deleteXML(this.getQuery());
			}
		}

		/// <summary>
		/// id,qidŎw肳ꂽʒuXPathԂ܂
		/// </summary>
		public string getQuery() 
		{
			string ret;

			string[] qidarr = this.qid.Split(':');
			string qid0 = qidarr[0];
			ret = "/ND/Questions[header/id='" + this.id + "']/detail/question[qid='" + qidarr[0] + "']";
			for ( int i=1; i<qidarr.Length; i++ ) 
			{
				if ( (i%2) == 1 ) 
				{
					ret += "/answer";
				}
				else 
				{
					ret += "/question";
				}
				ret += "[qid='" + qid0 + ":" + qidarr[i] + "']";
				qid0 += ":" + qidarr[i];
			}
			return ret;
		}

		/// <summary>
		/// XgApXMLԂ܂B
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		/// <param name="tgt">܂͉񓚂 "question"/"answer"</param>
		public string OuterXMLforStore(NeoCoreAPI neo, string tgt) 
		{
			this.addQuestionInfo(neo, tgt);
			return this.OuterXml; 
		}

		/// <summary>
		/// wb_t
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		/// <param name="tgt">܂͉񓚂 "question"/"answer"</param>
		private void addQuestionInfo(NeoCoreAPI neo, string tgt) 
		{
			string qid = this.getNextID(neo, tgt);
			XmlNode a = this.DocumentElement.SelectSingleNode(".");
			XmlElement new_elem1 = CreateElement("qid");
			XmlElement new_elem2 = CreateElement("date");
			
			new_elem1.InnerText = qid;
			new_elem2.InnerText = System.DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss");
			
			a.AppendChild(new_elem1);
			a.AppendChild(new_elem2);
		}

		/// <summary>
		/// id̔Ԃ
		/// </summary>
		/// <param name="neo">NeoCore XMS T[oڑq</param>
		/// <param name="tgt">܂͉񓚂 "question"/"answer"</param>
		private string getNextID(NeoCoreAPI neo, string tgt) 
		{
			XmlDocument doc0 = new XmlDocument();
			doc0.LoadXml(neo.queryXML(this.getQuery() + "/qid"));
			XmlNodeList qList0 = doc0.SelectNodes("/Query-Results/qid");
			string qid0 = qList0[0].InnerText;

			XmlDocument doc = new XmlDocument();
			doc.LoadXml(neo.queryXML(this.getQuery() + "/" + tgt + "/qid"));
			XmlNodeList qList = doc.SelectNodes("/Query-Results/qid");			

			if ( qList.Count == 0 ) 
			{
				return qid0 + ":1";
			}
			else 
			{
				int max_id = 0;
				for(int i=0; i<qList.Count; i++) 
				{
					string[] qid = qList[i].InnerText.Split(':');
					int cur_id = int.Parse(qid[qid.Length-1]);
					if ( cur_id > max_id ) max_id = cur_id;
				}
				int next_id = max_id + 1;
				return qid0 + ":" + next_id.ToString();
			}
		}
	}
}
