<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:import href="functions.xsl" />
<xsl:output encoding="Shift_JIS" />
<xsl:template match="/">
	<xsl:apply-templates select="Query-Results/Questions" />
</xsl:template>

<xsl:template match="Query-Results/Questions">
<html>
	<HEAD>
		<title>question detail</title>
	</HEAD>
	<body leftMargin="0" topMargin="0" rightMargin="0">
		<FONT face="MS UI Gothic">
			<TABLE id="Table5" cellSpacing="0" cellPadding="0" width="100%" border="0">
				<TR>
					<TD><IMG alt="NeoCoreロゴ" src="images/logo-neocore.gif" /></TD>
				</TR>
				<TR>
					<TD bgColor="#0066cc">
						<FONT face="ＭＳ Ｐゴシック" color="#ffffff" size="6">NeoCoreFAQ</FONT> <FONT size="2">Powered 
							by NeoCore(R) XMS </FONT>
					</TD>
				</TR>
			</TABLE>
			<table cellSpacing="0" cellPadding="0" width="100%" border="0">
				<TR bgcolor="#AABBCC">
					<TD width="40"><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></TD>
					<TD align="right">
						<a><xsl:attribute name="href">question_detail.aspx?from=index.aspx&amp;id=<xsl:value-of select="/Query-Results/Questions/header/id" /></xsl:attribute>[会話別]</a>　
						<a><xsl:attribute name="href"><xsl:value-of select="/Query-Results/Questions/fromurl" /></xsl:attribute>戻る</a>
					</TD>
				</TR>
				<TR>
					<TD><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></TD>
					<TD></TD>
				</TR>
				<TR>
					<TD></TD>
					<TD><b><font color="#000080"><xsl:value-of select="header/subject" /></font></b></TD>
				</TR>
				<TR>
					<TD></TD>
					<TD><xsl:apply-templates select="detail" /></TD>
				</TR>
			</table>
		</FONT>
	</body>
</html>
</xsl:template>

<xsl:template match="detail">
<table border="0" cellpadding="2" cellspacing="1">
  <xsl:apply-templates select="*" />
</table>
</xsl:template>

<xsl:template match="question">
<xsl:variable name="status" select="/Query-Results/Questions/header/status/text()"/>
<tr>
	<td bgcolor="#EEEEFF"><xsl:apply-templates select="from/description" /></td>
	<td bgcolor="#EEEEFF" align="right" valign="top"><xsl:value-of select="date" /></td>
	<xsl:if test="$status='open'">
	<td bgcolor="#EEEEFF"></td>
	</xsl:if>
</tr>
</xsl:template>

<xsl:template match="answer">
<xsl:variable name="status" select="/Query-Results/Questions/header/status/text()"/>
<tr>
	<td bgcolor="#FFEEEE"><xsl:apply-templates select="from/description" /></td>
	<td bgcolor="#FFEEEE" align="right" valign="top"><xsl:value-of select="date" /></td>
	<xsl:if test="$status='open'">
	<td bgcolor="#FFEEEE" align="right" valign="top">
		<a><xsl:attribute name="href">question_reply.aspx?id=<xsl:value-of select="/Query-Results/Questions/header/id" />&amp;qid=<xsl:value-of select="qid" />&amp;from=<xsl:value-of select="/Query-Results/Questions/fromurl" /></xsl:attribute>追加質問</a>
	</td>
	</xsl:if>
</tr>
</xsl:template>

<xsl:template match="from/description">
	<xsl:call-template name="br">
		<xsl:with-param name="msg" select="text()" />
	</xsl:call-template>
</xsl:template>

</xsl:stylesheet>

  