using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Xml.XPath;
using NEOCOREXMSLib;

namespace NeoCoreFAQ001
{
	/// <summary>
	/// Ǘʂ̃gbvy[WłBꗗ\܂B
	/// </summary>
	public class admin : System.Web.UI.Page
	{
		private NeoCoreAPI neo;
		protected System.Web.UI.WebControls.Table Table1;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.HyperLink LinkPassword;
		protected string userid;

		private void Page_Load(object sender, System.EventArgs e)
		{
			ListView();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
			neo = (NeoCoreAPI)Session["NeoCoreAPI"];
			userid = Session["userid"] as string;
			if ( userid == null ) Response.Redirect("auth.aspx?from=admin.aspx");
		}
		
		/// <summary>
		/// Designer T|[gɕKvȃ\bhłBR[h GfB^
		/// ̃\bh̃RecύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		/// <summary>
		/// ꗗ𐶐܂B
		/// </summary>
		private void ListView() 
		{
			XmlHeaderList doc = new XmlHeaderList(neo.queryXML("/ND/Questions/header"), "last-updated");
			TableRow titleRow = new TableRow();
			TableCell[] titleCells = new TableCell[3];
			titleCells[0] = new TableCell();
			titleCells[1] = new TableCell();
			titleCells[2] = new TableCell();
			titleCells[0].Text = "<b></b>";
			titleCells[1].Text = "<b></b>";
			titleCells[1].ColumnSpan = 2;
			titleCells[2].Text = "<b>ŏIXV</b>";
			titleRow.Cells.AddRange(titleCells);
			this.Table1.Rows.Add(titleRow);
			for (int i=0; i<doc.Count; i++)
			{
				this.Table1.Rows.Add(this.makeRow((Hashtable)doc.List[i]));
			}
		}

		/// <summary>
		/// ꗗ̂PR[h𐶐܂
		/// </summary>
		/// <param name="ht">̃wb_\nbVe[uIuWFNg</param>
		private TableRow makeRow(Hashtable ht) 
		{
			HyperLink h = new HyperLink();
			h.Text = ht["subject"].ToString();
			h.NavigateUrl = "answer_detail.aspx?id=" + ht["id"].ToString();

			Button s_button = new Button();
			s_button.ID = "s_" + ht["id"].ToString();
			s_button.Click += new System.EventHandler(this.sButton_Click);

			Button button = new Button();
			button.ID = ht["id"].ToString();
			button.Click += new System.EventHandler(this.Button_Click);

			int w = int.Parse(ht["waiting"].ToString());

			TableCell[] tCells = new TableCell[6];
			tCells[0] = new TableCell();
			tCells[1] = new TableCell();
			tCells[2] = new TableCell();
			tCells[3] = new TableCell();
			tCells[4] = new TableCell();
			tCells[5] = new TableCell();
			tCells[0].Controls.Add(h);
			tCells[2].Controls.Add(s_button);
			tCells[3].Text = ht["last-updated"].ToString();
			tCells[5].Controls.Add(button);

			TableRow tRow = new TableRow();
			tRow.Cells.AddRange(tCells);

			this.showStatus(s_button, ht["status"].ToString(), button, ht["secret"] as string, w);

			return tRow;
		}

		/// <summary>
		/// Xe[^Xɏ]āAꗗ̃Xe[^X̕AXe[^XύX{^̕w肵܂B
		/// </summary>
		/// <param name="b">Xe[^XύX{^̃{^Rg[IuWFNg</param>
		/// <param name="s">Xe[^X "open","close" </param>
		private void showStatus(Button sb, string sts, Button b, string s, int w) 
		{
			string sButtonStr = "openɂ";
			if ( sts == "open" ) 
			{
				sButtonStr = "closeɂ";
			}

			string buttonStr = "JȂ";
			if ( s != null ) 
			{
				buttonStr = "J";
			}
			string wmsg = "";
			if ( w > 0 ) 
			{
				wmsg = "񓚑҂";
			}
			if ( s != null ) 
			{
				wmsg = "J";
			}

			TableCell c = b.Parent as TableCell;
			TableRow r = c.Parent as TableRow;
			r.Cells[1].Text = sts;
			r.Cells[4].Text = wmsg;
			sb.Text = sButtonStr;
			b.Text = buttonStr;
			r.Attributes.Add("bgcolor", this.getRowBGCOLOR(w, s));
		}

		/// <summary>
		/// 񓚑҂AԂwiF擾
		/// </summary>
		/// <param name="w">񓚑҂</param>
		/// <param name="s">Xe[^X "open","close" </param>
		private string getRowBGCOLOR(int w, string s) 
		{
			string col = "white";
			if ( s != null ) col = "#CCCCCC";
			else 
			{
				if ( w == 0 ) col = "#CCCCFF";
				if ( w > 0 ) col = "#FFCCCC";
			}
			return col;
		}

		/// <summary>
		/// JJύX{^NbN̏
		/// </summary>
		private void Button_Click(object sender, System.EventArgs e) 
		{
			Button b = sender as Button;
			XmlQuestions q = new XmlQuestions(neo, b.ID, "");
			string chgStr = q.secretUpdate(neo);
			TableRow r = (TableRow)b.Parent.Parent;
			this.showStatus((Button)r.Cells[2].Controls[0], q.getStatus(), b, chgStr, q.getWaiting());
		}

		/// <summary>
		/// Xe[^XύX{^NbN̏
		/// </summary>
		private void sButton_Click(object sender, System.EventArgs e) 
		{
			Button b = sender as Button;
			string[] t = b.ID.Split('_');
			XmlQuestions q = new XmlQuestions(neo, t[1], "");
			string chgStr = q.statusUpdate(neo);
			TableRow r = (TableRow)b.Parent.Parent;
			this.showStatus(b, chgStr, (Button)r.Cells[5].Controls[0], q.getSecret(), q.getWaiting());
		}
	}
}
