<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:import href="functions.xsl" />
<xsl:output encoding="Shift_JIS" />
<xsl:template match="/">
  <xsl:apply-templates select="Query-Results/Questions" />
</xsl:template>

<xsl:template match="Query-Results/Questions">
<html>
	<HEAD>
		<title>question detail</title>
	</HEAD>
	<body leftMargin="0" rightMargin="0" topMargin="0">
		<FONT face="MS UI Gothic">
			<TABLE id="Table5" cellSpacing="0" cellPadding="0" width="100%" border="0">
				<TR>
					<TD><IMG alt="NeoCoreロゴ" src="images/logo-neocore.gif" /></TD>
				</TR>
				<TR bgColor="#FFCC66">
					<TD>
						<FONT face="ＭＳ Ｐゴシック" color="#ffffff" size="6">NeoCoreFAQ</FONT> <FONT size="2">Powered 
							by NeoCore(R) XMS </FONT>
					</TD>
					<td align="right">
						<font color="white" size="4">管理画面</font>
					</td>
				</TR>
			</TABLE>
			<table cellSpacing="0" cellPadding="0" width="100%" border="0">
				<TR bgcolor="#ffeedd">
					<TD width="40"><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></TD>
					<TD align="right">
						<a><xsl:attribute name="href">answer_detail.aspx?from=index.aspx&amp;id=<xsl:value-of select="/Query-Results/Questions/header/id" /></xsl:attribute>[会話別]</a>　
						<a><xsl:attribute name="href">admin.aspx</xsl:attribute>戻る</a>
					</TD>
				</TR>
				<TR>
					<TD><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></TD>
					<TD></TD>
				</TR>
				<tr>
					<TD></TD>
					<td><b><font color="#000080"><xsl:value-of select="header/subject" /></font></b></td>
				</tr>
				<tr>
					<TD></TD>
					<td><xsl:apply-templates select="detail" /></td>
				</tr>
			</table>
			
		</FONT>
	</body>
</html>
</xsl:template>

<xsl:template match="detail">
<table border="0" cellpadding="2" cellspacing="1">
	<xsl:apply-templates select="*" />
</table>
</xsl:template>

<xsl:template match="question">
<xsl:variable name="qid" select="qid"/>
<tr>
	<td bgcolor="#EEEEFF"><xsl:apply-templates select="from/description" /></td>
	<td bgcolor="#EEEEFF" align="right" valign="top"><xsl:value-of select="date" /></td>
	<td bgcolor="#EEEEFF" align="right" valign="top">
		<a><xsl:attribute name="href">answer_reply.aspx?id=<xsl:value-of select="/Query-Results/Questions/header/id" />&amp;qid=<xsl:value-of select="qid" /></xsl:attribute>返答する</a>
	</td>
	<td bgcolor="#EEEEFF" align="right" valign="top">
	<xsl:if test="$qid!='1'">
		<a><xsl:attribute name="href">delete.aspx?from=answer_detail2.aspx&amp;id=<xsl:value-of select="/Query-Results/Questions/header/id" />&amp;qid=<xsl:value-of select="qid" /></xsl:attribute>削除</a>
	</xsl:if>
	</td>
</tr>
</xsl:template>

<xsl:template match="answer">
<tr>
	<td bgcolor="#FFEEEE"><xsl:apply-templates select="from/description" /></td>
	<td bgcolor="#FFEEEE" align="right" valign="top"><xsl:value-of select="date" /></td>
	<td bgcolor="#FFEEEE"></td>
	<td bgcolor="#FFEEEE" align="right" valign="top">
		<a><xsl:attribute name="href">delete.aspx?from=answer_detail2.aspx&amp;id=<xsl:value-of select="/Query-Results/Questions/header/id" />&amp;qid=<xsl:value-of select="qid" /></xsl:attribute>削除</a>
	</td>
</tr>
</xsl:template>

<xsl:template match="from/description">
	<xsl:call-template name="br">
		<xsl:with-param name="msg" select="text()" />
	</xsl:call-template>
</xsl:template>

</xsl:stylesheet>

  