using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using NEOCOREXMSLib;

namespace NeoCoreFAQ001
{
	/// <summary>
	/// search_result ̊Tv̐łB
	/// </summary>
	public class search_result : System.Web.UI.Page
	{
		private NeoCoreAPI neo;
		protected System.Web.UI.WebControls.Label LabelSearchResult;
		protected System.Web.UI.WebControls.HyperLink HyperLinkGoTop;
		protected System.Web.UI.WebControls.Table Table1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if ( Request.HttpMethod == "GET" ) 
			{
				ListView();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
			neo = (NeoCoreAPI)Session["NeoCoreAPI"];
		}
		
		/// <summary>
		/// Designer T|[gɕKvȃ\bhłBR[h GfB^
		/// ̃\bh̃RecύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ListView() 
		{
			XmlHeaderList doc = new XmlHeaderList(neo.queryXML("/ND/Questions[contains(header/subject/descendant::text(),'" + Request["s"] + "') or contains(detail/descendant::text(),'" + Request["s"] + "')]/header[count(secret)=0]"), "last-updated");
			TableRow titleRow = new TableRow();
			TableCell titleCell1 = new TableCell();
			titleCell1.Controls.Add(new LiteralControl("<b></b>"));
			titleRow.Cells.Add(titleCell1);
			TableCell titleCell2 = new TableCell();
			titleCell2.Controls.Add(new LiteralControl("<b>ŏIXV</b>"));
			titleRow.Cells.Add(titleCell2);
			this.Table1.Rows.Add(titleRow);

			string col;
			for (int i=0; i<doc.Count; i++)
			{
				col = "white";
				if ( (i%2) == 0 ) col = "#EEEEFF";
				this.Table1.Rows.Add(this.makeRow((Hashtable)doc.List[i], col));
			}
		}

		private TableRow makeRow(Hashtable ht, string col) 
		{
			HyperLink h = new HyperLink();
			h.Text = (string)ht["subject"];
			h.NavigateUrl = "question_detail.aspx?id=" + (string)ht["id"];

			TableCell tCell1 = new TableCell();
			tCell1.Controls.Add(new LiteralControl("E"));
			tCell1.Controls.Add(h);

			TableCell tCell2 = new TableCell();
			tCell2.Controls.Add(new LiteralControl("last update " + (string)ht["last-updated"]));

			TableRow tRow = new TableRow();
			tRow.Cells.Add(tCell1);
			tRow.Cells.Add(tCell2);

			tRow.Attributes.Add("bgcolor", col);

			return tRow;
		}

	}
}
